Index: src/org/opencms/widgets/CmsVfsFileWidget.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/widgets/CmsVfsFileWidget.java,v
retrieving revision 1.24
diff -u -r1.24 CmsVfsFileWidget.java
--- src/org/opencms/widgets/CmsVfsFileWidget.java	18 Jan 2010 10:01:01 -0000	1.24
+++ src/org/opencms/widgets/CmsVfsFileWidget.java	24 Aug 2010 16:43:28 -0000
@@ -32,10 +32,16 @@
 package org.opencms.widgets;
 
 import org.opencms.file.CmsObject;
+import org.opencms.loader.CmsLoaderException;
+import org.opencms.main.CmsLog;
 import org.opencms.main.OpenCms;
 import org.opencms.util.CmsStringUtil;
 import org.opencms.workplace.CmsWorkplace;
 
+import java.util.Arrays;
+
+import org.apache.commons.logging.Log;
+
 /**
  * Provides a OpenCms VFS file selection widget, for use on a widget dialog.<p>
  *
@@ -47,6 +53,9 @@
  */
 public class CmsVfsFileWidget extends A_CmsWidget {
 
+    /** The static log object for this class. */
+    private static final Log LOG = CmsLog.getLog(CmsVfsFileWidget.class);
+    
     /** Configuration parameter to set the flag to include files in popup resource tree. */
     public static final String CONFIGURATION_EXCLUDEFILES = "excludefiles";
 
@@ -68,6 +77,9 @@
     /** Configuration parameter to set start site of the popup resource tree. */
     public static final String CONFIGURATION_STARTSITE = "startsite";
 
+    /** Configuration parameter to set the name of the resource types to accept. */
+    public static final String CONFIGURATION_RESOURCETYPENAMES = "resourcetypeNames";
+
     /** Flag to determine if files should be shown in popup window. */
     private boolean m_includeFiles;
 
@@ -80,6 +92,9 @@
     /** The start site used in the popup window. */
     private String m_startSite;
 
+    /** The value for the resource types to accept. */
+    private String[] m_resourcetypeNames;
+
     /**
      * Creates a new vfs file widget.<p>
      */
@@ -121,11 +136,25 @@
      * @param projectAware <code>true</code> if resources outside of the current project should be displayed as normal
      */
     public CmsVfsFileWidget(boolean showSiteSelector, String startSite, boolean includeFiles, boolean projectAware) {
+        this(showSiteSelector, startSite, includeFiles, projectAware, null);
+    }
+
+    /**
+     * Creates a new vfs file widget with the parameters to configure the popup tree window behavior.<p>
+     * 
+     * @param showSiteSelector true if the site selector should be shown in the popup window
+     * @param startSite the start site root for the popup window
+     * @param includeFiles <code>true</code> if files should be shown in the popup window
+     * @param projectAware <code>true</code> if resources outside of the current project should be displayed as normal
+     * @param resourcetypeNames the resource types to accept.
+     */
+    public CmsVfsFileWidget(boolean showSiteSelector, String startSite, boolean includeFiles, boolean projectAware, String[] resourcetypeNames) {
 
         m_showSiteSelector = showSiteSelector;
         m_startSite = startSite;
         m_includeFiles = includeFiles;
         m_projectAware = projectAware;
+        m_resourcetypeNames = resourcetypeNames;
     }
 
     /**
@@ -176,7 +205,19 @@
         } else {
             result.append(CONFIGURATION_NOTPROJECTAWARE);
         }
-
+        // S.Softic append flag for file restrictions
+        if (m_resourcetypeNames != null && m_resourcetypeNames.length > 0) {
+            result.append("|");
+            result.append(CONFIGURATION_RESOURCETYPENAMES);
+            result.append("=");
+            result.append(CmsStringUtil.arrayAsString(
+                m_resourcetypeNames,
+                ","));
+        }
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("m_resourcetypeNames: " + Arrays.toString(m_resourcetypeNames));
+            LOG.debug(result.toString());
+        }
         return result.toString();
     }
 
@@ -230,7 +271,8 @@
     public String getDialogWidget(CmsObject cms, I_CmsWidgetDialog widgetDialog, I_CmsWidgetParameter param) {
 
         String id = param.getId();
-        StringBuffer result = new StringBuffer(128);
+        // S.Softic adding some space to the buffer        
+        StringBuffer result = new StringBuffer(200);
 
         result.append("<td class=\"xmlTd\">");
         result.append("<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"maxwidth\"><tr><td style=\"width: 100%;\">");
@@ -248,7 +290,8 @@
         result.append(widgetDialog.dialogHorizontalSpacer(10));
         result.append("<td><table class=\"editorbuttonbackground\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr>");
 
-        StringBuffer buttonJs = new StringBuffer(8);
+        // S.Softic adding some space to the buffer
+        StringBuffer buttonJs = new StringBuffer(35);
         buttonJs.append("javascript:openTreeWin('EDITOR',  '");
         buttonJs.append(id);
         buttonJs.append("', document, ");
@@ -265,7 +308,10 @@
         // project awareness
         buttonJs.append(", ");
         buttonJs.append(m_projectAware);
-        buttonJs.append(");return false;");
+        // resourcetypeIds
+        buttonJs.append(", '");
+        buttonJs.append(getRestrictResTypeIdsAsString(","));
+        buttonJs.append("');return false;");
 
         result.append(widgetDialog.button(
             buttonJs.toString(),
@@ -347,7 +393,55 @@
                 // resources outside of the current project should not be disabled
                 m_projectAware = false;
             }
+          
+            //setting the configuration
+            if (configuration.indexOf(CONFIGURATION_RESOURCETYPENAMES) !=-1) {
+                   String restriction = configuration.substring(configuration.indexOf(CONFIGURATION_RESOURCETYPENAMES)+CONFIGURATION_RESOURCETYPENAMES.length() + 1);
+                if (restriction.indexOf('|') != -1) {
+                    // cut eventual following configuration values
+                    restriction = restriction.substring(0, restriction.indexOf('|'));
+                }
+                else {
+                    restriction = restriction.substring(0, restriction.length());
+                }
+
+                m_resourcetypeNames = CmsStringUtil.splitAsArray(
+                    restriction,
+                    ",");
+                if (LOG.isDebugEnabled()) {
+                    LOG.debug("m_restrictResTypes.length: " + m_resourcetypeNames.length);
+                    LOG.debug("m_restrictResTypes: " + Arrays.toString(m_resourcetypeNames));
+                }
+            }
         }
         super.setConfiguration(configuration);
     }
+    
+    /**
+     * Get The restricted ResourceType Ids as String with the given delimiter.
+     * 
+     * @param delimiter
+     * @return String of Ids
+     */
+    protected String getRestrictResTypeIdsAsString(String delimiter) {
+        if (m_resourcetypeNames == null) {
+            //TODO Harald.Brabenetz 28.01.2010 : Check if this should return null or empty String.
+            return "";
+        }
+        StringBuffer result = new StringBuffer();
+        for (int i = 0; i < m_resourcetypeNames.length; i++) {
+            String resourceTypeName = m_resourcetypeNames[i];
+            try {
+                int id = OpenCms.getResourceManager().getResourceType(resourceTypeName).getTypeId();
+                if (result.length() > 0) {
+                    result.append(delimiter);
+                }
+                LOG.info("append id: " + id);
+                result.append(id);
+            } catch (CmsLoaderException e) {
+                LOG.warn("No id found for ResourceTyp '" + resourceTypeName + "'", e);
+            }
+        }
+        return result.toString();
+    }
 }
Index: src/org/opencms/workplace/CmsWidgetDialog.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/workplace/CmsWidgetDialog.java,v
retrieving revision 1.73
diff -u -r1.73 CmsWidgetDialog.java
--- src/org/opencms/workplace/CmsWidgetDialog.java	18 Jan 2010 10:03:37 -0000	1.73
+++ src/org/opencms/workplace/CmsWidgetDialog.java	24 Aug 2010 16:43:28 -0000
@@ -238,7 +238,7 @@
             href.append(elementName);
             href.append("', ");
             href.append(insertAfter);
-            href.append(");");
+            href.append(",[]);");
             return button(href.toString(), null, "new.png", Messages.GUI_DIALOG_BUTTON_ADDNEW_0, 0);
         } else {
             return "";
Index: src/org/opencms/workplace/CmsWorkplace.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/workplace/CmsWorkplace.java,v
retrieving revision 1.180
diff -u -r1.180 CmsWorkplace.java
--- src/org/opencms/workplace/CmsWorkplace.java	18 Jan 2010 10:03:36 -0000	1.180
+++ src/org/opencms/workplace/CmsWorkplace.java	24 Aug 2010 16:43:28 -0000
@@ -748,7 +748,7 @@
 
         String anchorStart = "<a href=\"";
         if ((href != null) && href.toLowerCase().startsWith("javascript:")) {
-            anchorStart = "<a href=\"#\" onclick=\"";
+            anchorStart = "<a href=\"javascript:;\" onclick=\""; //use "javascript:;" instead of "#" => don't jump to the Top of the page.
         }
 
         result.append("<td style=\"vertical-align: top;\">");
